# Sonar Scanning Examples

This repository showcases basic examples of usage and code coverage for SonarScanners.
* [SonarScanner for Gradle](https://docs.sonarsource.com/sonarqube/latest/analyzing-source-code/scanners/sonarscanner-for-gradle)
* [SonarScanner for .NET](https://docs.sonarsource.com/sonarqube/latest/analyzing-source-code/scanners/sonarscanner-for-dotnet)
* [SonarScanner for Maven](https://docs.sonarsource.com/sonarqube/latest/analyzing-source-code/scanners/sonarscanner-for-maven)
* [SonarScanner for Ant](https://docs.sonarsource.com/sonarqube/latest/analyzing-source-code/scanners/sonarscanner-for-ant) - This scanner is now deprecated. See link for more details.
* [SonarScanner CLI](https://docs.sonarsource.com/sonarqube/latest/analyzing-source-code/scanners/sonarscanner)

Sonar's [Clean Code solution](https://www.sonarsource.com/solutions/clean-code/) helps developers deliver high-quality, efficient code standards that benefit the entire team or organization. 

## Examples
### Various Languages
* [SonarScanner for various languages](sonar-scanner)

### Ant
[SonarScanner for Ant](https://docs.sonarsource.com/sonarqube/latest/analyzing-source-code/scanners/sonarscanner-for-ant) is now deprecated. Please migrate to the SonarScanner CLI.
* [SonarScanner for Ant - Basic](sonar-scanner-ant/ant-basic)
* [SonarScanner for Ant - Code Coverage](sonar-scanner-ant/ant-coverage)

### Gradle
If you have a Gradle project, we recommend usage of [SonarScanner for Gradle](https://docs.sonarsource.com/sonarqube/latest/analyzing-source-code/scanners/sonarscanner-for-gradle) or the equivalent SonarScanner for Gradle on your CI pipeline.
* [SonarScanner for Gradle - Basic](sonar-scanner-gradle/gradle-basic)
* [SonarScanner for Gradle - Kotlin DSL](sonar-scanner-gradle/gradle-kotlin-dsl)
* [SonarScanner for Gradle - Multi-Module](sonar-scanner-gradle/gradle-multimodule)
* [SonarScanner for Gradle - Multi-Module Code Coverage](sonar-scanner-gradle/gradle-multimodule-coverage)

### Maven
If you have a Maven project, we recommend the usage of [SonarScanner for Maven](https://docs.sonarsource.com/sonarqube/latest/analyzing-source-code/scanners/sonarscanner-for-maven) or the equivalent SonarScanner for Maven on your CI pipeline.
* [SonarScanner for Maven - Basic](sonar-scanner-maven/maven-basic)
* [SonarScanner for Maven - Multilingual (Java + Kotlin with coverage)](sonar-scanner-maven/maven-multilingual)
* [SonarScanner for Maven - Multi-Module](sonar-scanner-maven/maven-multimodule)

### DotNet/C#
If you have a .NET project, we recommend the usage of [SonarScanner for .NET](https://docs.sonarsource.com/sonarqube/latest/analyzing-source-code/scanners/sonarscanner-for-dotnet) or the equivalent SonarScanner for .NET on your CI pipeline.
* [SonarScanner for .NET/MSBuild - C#](sonar-scanner-msbuild/CSharpProject)

### Swift
[SonarScanner - Swift Code Coverage](swift-coverage)

### C/C++/Objective-C
**_NOTE:_** All SonarScanner examples for C, C++ and Objective-C can be found [here](https://github.com/sonarsource-cfamily-examples).

## License
Copyright 2016-2023 SonarSource.

Licensed under the [GNU Lesser General Public License, Version 3.0](http://www.gnu.org/licenses/lgpl.txt)
